<?php
// Include the database configuration file
include('config.php');

// Retrieve callback data
$callbackData = file_get_contents('php://input');
$data = json_decode($callbackData, true);

// Log callback data for debugging
file_put_contents('mpesa_callback_log.txt', json_encode($data) . PHP_EOL, FILE_APPEND);

// Send 200 OK response to Safaricom
http_response_code(200);

// Database insertion logic
if (isset($data['Body']['stkCallback']['ResultCode'])) {
    $resultCode = $data['Body']['stkCallback']['ResultCode'];
    $resultDesc = $data['Body']['stkCallback']['ResultDesc'];
    $merchantRequestID = $data['Body']['stkCallback']['MerchantRequestID'] ?? null;
    $checkoutRequestID = $data['Body']['stkCallback']['CheckoutRequestID'] ?? null;
    $mpesaReceiptNumber = $data['Body']['stkCallback']['CallbackMetadata']['Item'][1]['Value'] ?? null;
    $amountPaid = $data['Body']['stkCallback']['CallbackMetadata']['Item'][0]['Value'] ?? null;
    $phoneNumber = $data['Body']['stkCallback']['CallbackMetadata']['Item'][2]['Value'] ?? null;
    $transactionDate = date('Y-m-d H:i:s'); // Set the current timestamp

    // Log the received data for debugging
    file_put_contents('mpesa_received_log.txt', "MerchantRequestID: $merchantRequestID, CheckoutRequestID: $checkoutRequestID, Amount: $amountPaid, Phone: $phoneNumber, Receipt: $mpesaReceiptNumber" . PHP_EOL, FILE_APPEND);

    // Example logic: Save to database or perform additional processing
    if ($resultCode == 0) {
        // Payment successful
        // Prepare SQL query to insert data into transactions table
        $sql = "INSERT INTO transactions (receipt_number, amount, phone_number, transaction_date, created_at, merchant_request_id, checkout_request_id)
                VALUES ('$mpesaReceiptNumber', '$amountPaid', '$phoneNumber', '$transactionDate', '$transactionDate', '$merchantRequestID', '$checkoutRequestID')";

        if ($conn->query($sql) === TRUE) {
            // Log successful payment
            file_put_contents('mpesa_success_log.txt', "Payment Successful: Receipt: $mpesaReceiptNumber, Amount: $amountPaid, Phone: $phoneNumber, MerchantRequestID: $merchantRequestID, CheckoutRequestID: $checkoutRequestID" . PHP_EOL, FILE_APPEND);
        } else {
            // Log SQL error
            file_put_contents('mpesa_error_log.txt', "Error: " . $conn->error . PHP_EOL, FILE_APPEND);
        }
    } else {
        // Payment failed
        file_put_contents('mpesa_error_log.txt', "Payment Failed: $resultDesc" . PHP_EOL, FILE_APPEND);
    }
}

// Close database connection
$conn->close();
?>
