<?php

require_once 'config.php';

header('Content-Type: application/json');

if (!isset($_GET['transactionId']) || empty($_GET['transactionId'])) {
    echo json_encode(['status' => 'error', 'message' => 'Transaction ID is required.']);
    exit;
}

$transactionId = $_GET['transactionId'];

$stmt = $conn->prepare("SELECT receipt_number, amount, phone_number, transaction_date FROM transactions WHERE receipt_number = ?");
$stmt->bind_param("s", $transactionId);
$stmt->execute();
$result = $stmt->get_result();

if ($result->num_rows > 0) {
    $transaction = $result->fetch_assoc();
    echo json_encode(['status' => 'success', 'data' => $transaction]);
} else {
    echo json_encode(['status' => 'error', 'message' => 'Transaction not found.']);
}

$stmt->close();
$conn->close();
?>
