<?php
// Enable CORS for development purposes
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json");

// Include the database configuration file
include_once 'config.php';

// Check if the database connection is set
if (!$conn) {
    http_response_code(500);
    echo json_encode(["error" => "Database connection failed"]);
    exit();
}

// Query to retrieve active insurance schemes
$sql = "SELECT id, name, description, price, status FROM insurance_schemes WHERE status = 'active'";
$result = $conn->query($sql);

// Check if there are active records
if ($result->num_rows > 0) {
    $insuranceSchemes = [];

    while ($row = $result->fetch_assoc()) {
        $insuranceSchemes[] = [
            "id" => $row["id"],
            "name" => $row["name"],
            "description" => $row["description"],
            "price" => $row["price"],
            "status" => $row["status"],
        ];
    }

    // Return the data in JSON format
    echo json_encode($insuranceSchemes);
} else {
    // No active data found
    http_response_code(404);
    echo json_encode(["message" => "No active insurance schemes found"]);
}

// Close the database connection
$conn->close();
?>
