<?php

echo '<a href="index.php">Home<br /></a>';

$content = file_get_contents('php://input'); // Receives the JSON Result from Safaricom
$res = json_decode($content, true); // Convert the JSON to an array

$dataToLog = array(
    date("Y-m-d H:i:s"), // Date and time
    "MerchantRequestID: " . $res['Body']['stkCallback']['MerchantRequestID'],
    "CheckoutRequestID: " . $res['Body']['stkCallback']['CheckoutRequestID'],
    "ResultCode: " . $res['Body']['stkCallback']['ResultCode'],
    "ResultDesc: " . $res['Body']['stkCallback']['ResultDesc'],
);

$data = implode(" - ", $dataToLog);
$data .= PHP_EOL;
file_put_contents('transaction_log', $data, FILE_APPEND); // Logs the results to the log file

// Include the database configuration file
include('config.php');

try {
    // Fetch the latest order
    $query = "SELECT * FROM orders ORDER BY Id DESC LIMIT 1";
    $result = $conn->query($query);
    $row = $result->fetch_assoc(); // Fetch a single row as an associative array

    if ($row) {
        $ID = $row['Id'];

        // Update the status based on the ResultCode
        if ($res['Body']['stkCallback']['ResultCode'] == '1032') {
            $updateQuery = "UPDATE `orders` SET `Status` = 'CANCELLED' WHERE `Id` = $ID";
        } else {
            $updateQuery = "UPDATE `orders` SET `Status` = 'SUCCESS' WHERE `Id` = $ID";
        }

        if ($conn->query($updateQuery) === TRUE) {
            file_put_contents('error_log', "Records Updated Successfully" . PHP_EOL, FILE_APPEND);
        } else {
            file_put_contents('error_log', "Failed to update records: " . $conn->error . PHP_EOL, FILE_APPEND);
        }
    } else {
        file_put_contents('error_log', "No records found in the orders table" . PHP_EOL, FILE_APPEND);
    }
} catch (Exception $e) {
    file_put_contents('error_log', "Error: " . $e->getMessage() . PHP_EOL, FILE_APPEND);
}

?>
