<?php

class MpesaPayment
{
    private $consumerKey = 'pXNh98H48GMKn661k4gh2a7EAN8pxqmGiSJIxSLxSGhEVJCt';
    private $consumerSecret = 'ppQUVQWEyS8WPKto2cAqzlTEWEaHGxXArgd7ofZc04h8X5WZ5cUt5Z1A3n1pLJWA';
    private $shortCode = '174379'; // Your Mpesa shortcode (Paybill or Till number)
    private $passKey = 'bfb279f9aa9bdbcf158e97dd71a467cd2e0c893059b10f78e6b72ada1ed2c919'; // Mpesa Passkey
    private $env = 'sandbox'; // Set to 'production' for live environment

    private function getAccessToken()
    {
        $url = $this->env === 'sandbox'
            ? 'https://sandbox.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials'
            : 'https://api.safaricom.co.ke/oauth/v1/generate?grant_type=client_credentials';

        $credentials = base64_encode("{$this->consumerKey}:{$this->consumerSecret}");

        $headers = [
            'Authorization: Basic ' . $credentials,
        ];

        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        $response = curl_exec($curl);
        curl_close($curl);

        $response = json_decode($response, true);
        return $response['access_token'] ?? null;
    }

    public function processPayment($phoneNumber, $amount, $accountReference, $callbackUrl)
    {
        $accessToken = $this->getAccessToken();

        if (!$accessToken) {
            return ['status' => 'error', 'message' => 'Unable to get access token'];
        }

        $url = $this->env === 'sandbox'
            ? 'https://sandbox.safaricom.co.ke/mpesa/stkpush/v1/processrequest'
            : 'https://api.safaricom.co.ke/mpesa/stkpush/v1/processrequest';

        $headers = [
            'Authorization: Bearer ' . $accessToken,
            'Content-Type: application/json',
        ];

        $payload = json_encode([
            'BusinessShortCode' => $this->shortCode,
            'Password' => base64_encode($this->shortCode . $this->passKey . date('YmdHis')),
            'Timestamp' => date('YmdHis'),
            'TransactionType' => 'CustomerPayBillOnline',
            'Amount' => $amount,
            'PartyA' => $phoneNumber,
            'PartyB' => $this->shortCode,
            'PhoneNumber' => $phoneNumber,
            'CallBackURL' => $callbackUrl,
            'AccountReference' => $accountReference,
            'TransactionDesc' => 'Payment for Policy'
        ]);

        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $payload);
        $response = curl_exec($curl);
        curl_close($curl);

        $response = json_decode($response, true);

        // Log the response for debugging
        file_put_contents('mpesa_payment_log.txt', json_encode($response) . PHP_EOL, FILE_APPEND);

        if (isset($response['ResponseCode']) && $response['ResponseCode'] == '0') {
            return ['status' => 'success', 'message' => 'Payment initiated successfully'];
        }

        return ['status' => 'error', 'message' => $response['errorMessage'] ?? 'Unknown error'];
    }
}

$payment = new MpesaPayment();
$phoneNumber = 254722727696; // Example phone number
$amount = 1; // Example amount
$accountReference = 'Policy12345';
$callbackUrl = 'https://insurance.maahub.co.ke/callback.php'; // Callback URL

$response = $payment->processPayment($phoneNumber, $amount, $accountReference, $callbackUrl);
echo json_encode($response);

?>
