<?php
// register_users.php

header("Content-Type: application/json");

require_once 'config.php';

// Get JSON input from the request body
$data = json_decode(file_get_contents("php://input"), true);

// Validate required fields
$requiredFields = [
    "fullName",
    "nationalId",
    "mobileNumber",
    "gender",
    "county",
    "dob",
    "email",
    "password",
    "confirmPassword"
];

foreach ($requiredFields as $field) {
    if (empty($data[$field])) {
        echo json_encode([
            "success" => false,
            "message" => "Field '$field' is required."
        ]);
        exit();
    }
}

// Check if passwords match
if ($data["password"] !== $data["confirmPassword"]) {
    echo json_encode([
        "success" => false,
        "message" => "Passwords do not match."
    ]);
    exit();
}

// Prepare SQL query
$fullName = $conn->real_escape_string($data["fullName"]);
$nationalId = $conn->real_escape_string($data["nationalId"]);
$mobileNumber = $conn->real_escape_string($data["mobileNumber"]);
$gender = $conn->real_escape_string($data["gender"]);
$county = $conn->real_escape_string($data["county"]);
$dob = $conn->real_escape_string($data["dob"]);
$email = $conn->real_escape_string($data["email"]);
$password = password_hash($data["password"], PASSWORD_DEFAULT); // Hash the password

// Check if the user already exists
$checkQuery = "SELECT * FROM users WHERE email = '$email' OR nationalId = '$nationalId'";
$result = $conn->query($checkQuery);

if ($result->num_rows > 0) {
    echo json_encode([
        "success" => false,
        "message" => "A user with this email or National ID already exists."
    ]);
    exit();
}

// Insert user into the database
$insertQuery = "INSERT INTO users (fullName, nationalId, mobileNumber, gender, county, dob, email, password) 
                VALUES ('$fullName', '$nationalId', '$mobileNumber', '$gender', '$county', '$dob', '$email', '$password')";

if ($conn->query($insertQuery) === TRUE) {
    echo json_encode([
        "success" => true,
        "message" => "Registration successful."
    ]);
} else {
    echo json_encode([
        "success" => false,
        "message" => "Error: " . $conn->error
    ]);
}

// Close the connection
$conn->close();
?>
